#################################################################
# Custom Page Mod 0.11                                          #
# Created by: James Andrews                                     #
# Modified by: Thomas Müller                                    #
# Modified for 2.7.00 by Dandello                               #
# ============================================================= #
# Visit my website:                                             #
# www.jamesandrews.info                                         #
# ============================================================= #
# Please report any bugs/fixes for this mod:                    #
# james.andrews89@ntlworld.com or at BoardMod.org               #
# ============================================================= #
# Enjoy turning your board into your website!                   #
#################################################################
use strict;
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.7.00';

our $custompageadminpmver = 'YaBB 2.7.00 $Revision: 0.11 $';
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }
my $pversion = '0.11';

our (
    $adminurl, $imagesdir,      $scripturl,     $title,
    $vardir,   $yymain,         $yysetlocation, $yytitle,
    %croak,    %CustomPage_txt, %FORM,          %INFO,
);

load_language('Mods/CustomPage');
load_language('Admin');

# Please feel free to translate into your own language and upload to BoardMod ;-)

sub CustomPage {
    my $pagelist = q{};
    our ($PAGE);
    if ( -e "$vardir/Mods/custompage.txt" ) {
    fopen( 'PAGE', '<', "$vardir/Mods/custompage.txt" );
    my @pages = <$PAGE>;
    fclose('PAGE');
    if (@pages) {
        $pagelist .= qq~<tr>
                <td class="windowbg center bold">$CustomPage_txt{'3'}</td>
                <td class="windowbg center bold">$CustomPage_txt{'3a'}</td>
                <td class="windowbg center bold">$CustomPage_txt{'5'}</td>
                <td class="windowbg center bold">$CustomPage_txt{'6'}</td>
                <td class="windowbg center bold">$CustomPage_txt{'9b'}</td>
                <td class="windowbg center bold">$CustomPage_txt{'30'}</td>
            </tr>~;

        foreach my $line (@pages) {
            my ( $query, $pagetitle, $useyabbc, $link, $click, $guest ) =
              split /[|]/xsm, $line;
            my $menu = $CustomPage_txt{'8'};
            if ( $link && $link == 1 ) {
                $menu = $CustomPage_txt{'7'};
            }
            else {
                $menu = $CustomPage_txt{'8'};
            }
            my $clickcount = $CustomPage_txt{'9'};
            if ( $click && $click == 1 ) {
                our ($COUNT);
                if ( -e "$vardir/Pages/$query.count" ) {
                    fopen( 'COUNT', '<', "$vardir/Pages/$query.count" );
                    my @count = <$COUNT>;
                    fclose('COUNT');
                    $clickcount = $count[0];
                }
            }
            else {
                $clickcount = $CustomPage_txt{'9'};
            }
            $pagelist .= qq~<tr>
                <td class="windowbg2 center">$pagetitle</td>
                <td class="windowbg2 center"><input type="button" value="$CustomPage_txt{'3a'}" onclick="location.href='$adminurl?action=pagemodify;id=$query'" /</td>
                <td class="windowbg2 center">$clickcount</td>
                <td class="windowbg2 center"><form name="cpcpurl"><input name="cpcpurl" type="text" size="65" maxlength="150" value="$scripturl?custompage=$query" readonly>&nbsp;<input type=button value="$CustomPage_txt{'9a'}" onClick="this.form.cpcpurl.select();this.form.cpcpurl.focus(); document.execCommand('Copy')"></form></td>
                <td class="windowbg2 center"><input type="button" value="$CustomPage_txt{'9b'}" onclick="location.href='$scripturl?custompage=$query'" /</td>
                <td class="windowbg2 center" style="width:30px"><input type="button" value="$CustomPage_txt{'30'}" style="float: right; width: 175px;" onclick="location.href='$adminurl?action=pagedelete;id=$query'" /></td>
            </tr>~;
        }
    }
	}
    else {
        $pagelist .=
          qq~<tr><td class="windowbg2 center">$CustomPage_txt{'10'}</td></tr>~;
    }
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="2"><img src="$imagesdir/preferences.gif" alt="$CustomPage_txt{'33'}" /><b>$CustomPage_txt{'33'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'4'}</td>
            </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="6"><img src="$imagesdir/preferences.gif" alt="" /> <b>$CustomPage_txt{'34'}</b></td>
            </tr>
            $pagelist
            <tr>
                <td class="windowbg center" style="height:30px" colspan="6"><a href="$adminurl?action=pagecreate"><b>$CustomPage_txt{'11'}</b></a></td>
            </tr>
        </table>
    </div>
    <div class="small center">Original Mod by James Andrews&nbsp;|&nbsp;Modified for YaBB 2.7.00 by Dandello<br />Version: $pversion</div>~;

    $yytitle = $CustomPage_txt{'24'};
    admintemplate();
    return;
}

sub PageCreate {

    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="2"><img src="$imagesdir/preferences.gif" alt="$CustomPage_txt{'33'}" /><b>$CustomPage_txt{'33'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'4a'}</td>
            </tr>
        </table>
    </div>
<form id="addnewpage" name="addnewpage" method="post" action="$adminurl?action=pagecreate2">
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <colgroup>
                <col width="50%" />
                <col width="50%" />
            </colgroup>
            <tr>
                <td class="titlebg" colspan="2"><b>$CustomPage_txt{'12'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'27'}<br />$CustomPage_txt{'13'}</td>
                <td class="windowbg2"><input name="title" type="text" id="title" value="$CustomPage_txt{'14'}" size="25" /></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'15'}<br />($CustomPage_txt{'13a'}<strong><u>query</u></strong>)</td>
                <td class="windowbg2"><input name="query" type="text" id="query" size="25" maxlength="15" /></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'16'}</td>
                <td class="windowbg2"><input name="yabbc" type="checkbox" id="yabbc" value="1" /></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'18'}</td>
                <td class="windowbg2"><input name="click" type="checkbox" checked="checked" id="click2" value="1" /></td>
            </tr>
       </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="2"><b>$CustomPage_txt{'20'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'21'} ($CustomPage_txt{'22'} $scripturl)</td>
            </tr><tr>
                <td class="windowbg2 center"><textarea name="html" cols="100" rows="30" id="html"></textarea></td>
            </tr><tr>
                <td class="windowbg2 center"><a href="$adminurl?action=pagecreate"></a><input type="submit" name="Submit" value="$CustomPage_txt{'28'}" />&nbsp;<input type="button" value="$CustomPage_txt{'35'}" onclick="history.back();"></td>
            </tr>
        </table>
    </div>
</form>~;

    $yytitle = $CustomPage_txt{'23'};
    admintemplate();
    return;
}

sub PageCreate2 {
    my $pagetitle = $FORM{'title'} || 'Untitled Page';
    my $guest     = $FORM{'guest'} || 0;
    my $query     = $FORM{'query'};
    my $useyabbc  = $FORM{'yabbc'} || 0;
    my $link      = $FORM{'link'}  || 0;
    my $click     = $FORM{'click'} || 0;
    my $html      = $FORM{'html'};
    $query =~ s/[^0-9A-Za-z]//gxsm;
    $pagetitle =~ s/[|]//gxsm;

    if ($query) {
        our ($PAGE);
        fopen( 'PAGE', '>', "$vardir/Pages/$query.txt" );
        print {$PAGE} $html or croak "$croak{'print'} html";
        fclose('PAGE');

        our ($SET);
        fopen( 'SET', '>>', "$vardir/Mods/custompage.txt" );
        print {$SET} "$query|$pagetitle|$useyabbc|$link|$click|$guest\n"
          or croak "$croak{'print'} page";
        fclose('SET');
    }
    $yysetlocation = "$adminurl?action=custompage";
    redirectexit();
    return;
}

sub PageModify {
    my $id = $INFO{'id'};
    our ($SET);
    fopen( 'SET', '<', "$vardir/Mods/custompage.txt" );
    my @set = <$SET>;
    fclose('SET');
    chomp @set;
    my $correctline = q{};
    foreach my $line (@set) {
        if ( $line =~ /\A\Q$id\E[|]/ixsm ) {
            $correctline = $line;
            last;
        }
    }
    my ( $query, $pagetitle, $useyabbc, $link, $click, $guest ) =
      split /[|]/xsm,
      $correctline;
    my $changeclicks = q{};
    if ( $click && $click == 1 ) {
        our ($COUNT);
        fopen( 'COUNT', '<', "$vardir/Pages/$id.count" );
        my @count = <$COUNT>;
        fclose('COUNT');
        $changeclicks .=
qq~$CustomPage_txt{'25'} <input name="clickcount" type="text" id="clickcount" value="$count[0]" />~;
    }
    our ($HTML);
    fopen( 'HTML', '<', "$vardir/Pages/$id.txt" );
    my @html = <$HTML>;
    fclose('HTML');
    chomp @html;
    my $html = join q{}, @html;
    my $check = q{};

    if ( $useyabbc == 1 ) {
        $check .= q~checked="checked"~;
    }
    else {
        $check = q{};
    }
    my $check2 = q{};
    if ( $link && $link == 1 ) {
        $check2 .= q~checked="checked"~;
    }
    else {
        $check2 = q{};
    }
    my $check3 = q{};
    if ( $click && $click == 1 ) {
        $check3 .= q~checked="checked"~;
    }
    else {
        $check3 = q{};
    }
    my $check4 = q{};
    if ( $guest && $guest == 1 ) {
        $check4 .= q~checked="checked"~;
    }
    else {
        $check4 = q{};
    }
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="2"><img src="$imagesdir/preferences.gif" alt="$CustomPage_txt{'33'}" /><b>$CustomPage_txt{'33'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'4b'}</td>
            </tr>
        </table>
    </div>
<form id="addnewpage" name="addnewpage" method="post" action="$adminurl?action=pagemodify2">
    <input type="hidden" name="id" value="$query" />
     <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <colgroup>
                <col width="50%" />
                <col width="50%" />
            </colgroup>
            <tr>
                <td class="titlebg" colspan="2"><b>$CustomPage_txt{'12a'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'27'}<br />$CustomPage_txt{'13'}</td>
                <td class="windowbg2"><input name="title" type="text" id="title" value="$pagetitle" size="25" /></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'15'}<br />($CustomPage_txt{'13a'}<strong><u>query</u></strong>)</td>
                <td class="windowbg2"><input name="query" type="text" id="query" maxlength="15" value="$query" /></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'16'}</td>
                <td class="windowbg2"><input name="yabbc" type="checkbox" id="yabbc" $check value="1" /></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'18'}</td>
                <td class="windowbg2"><input name="click" type="checkbox" $check3 id="click2" value="1" /></td>
            </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="2"><b>$CustomPage_txt{'20'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'21'} ($CustomPage_txt{'22'} $scripturl)</td>
            </tr><tr>
                <td class="windowbg2 center"><textarea name="html" cols="100" rows="30" id="html">$html</textarea></td>
            </tr><tr>
                <td class="windowbg2 center"><a href="$adminurl?action=pagecreate"></a><input type="submit" name="Submit" value="$CustomPage_txt{'28'}" />&nbsp;<input type="button" value="$CustomPage_txt{'35'}" onclick="history.back();"></td>
            </tr>
        </table>
    </div>
</form>
~;

    $yytitle = "$CustomPage_txt{'37'} - $pagetitle";
    admintemplate();
    return;
}

sub PageModify2 {
    my $id         = $FORM{'id'};
    my $pagetitle  = $FORM{'title'};
    my $query      = $FORM{'query'};
    my $guest      = $FORM{'guest'} || q{};
    my $clickcount = $FORM{'clickcount'};
    my $useyabbc   = $FORM{'yabbc'};
    my $link       = $FORM{'link'} || q{};
    my $click      = $FORM{'click'} || q{};
    my $html       = $FORM{'html'};
    $query =~ s/[^0-9A-Za-z]//gxsm;
    $pagetitle =~ s/[|]//gxsm;
    our ($SET);
    fopen( 'SET', '<', "$vardir/Mods/custompage.txt" );
    my @pages = <$SET>;
    fclose('SET');
    my @output = ();

    foreach my $line (@pages) {
        if ( $line !~ /\A\Q$id\E[|]/ism ) {
            push @output, $line;
        }
    }
    push @output, "$query|$pagetitle|$useyabbc|$link|$click|$guest";
    my $output = join q{}, @output;
    our ($SETT);
    fopen( 'SETT', '>', "$vardir/Mods/custompage.txt" );
    print {$SETT} "$output\n" or croak "$croak{'print'} output";
    fclose('SETT');
    if ( $id ne $query ) {
        unlink "$vardir/Pages/$id.txt";

        # Delete current html file if the query has changed.
    }
    our ($HTML);
    fopen( 'HTML', '>', "$vardir/Pages/$query.txt" );

    # Create new html file with new query.

    print {$HTML} $html or croak "$croak{'print'} html";
    fclose('HTML');
    if ($clickcount) {
        our ($COUNT);
        fopen( 'COUNT', '>', "$vardir/Pages/$query.count" );
        print {$COUNT} $clickcount or croak "$croak{'print'} clicks";
        fclose('COUNT');
    }
    $yysetlocation = "$adminurl?action=custompage";
    redirectexit();
    return;
}

sub PageDelete {
    my $id = $INFO{'id'};
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="2"><img src="$imagesdir/preferences.gif" alt="$CustomPage_txt{'28a'}" /><b>$CustomPage_txt{'28a'}</b></td>
            </tr><tr>
                <td class="windowbg2">$CustomPage_txt{'28b'}.</td>
            </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <colgroup>
                <col width="40%" />
                <col width="40%" />
                <col width="20%" />
            </colgroup>
            <tr>
                <td class="windowbg2">$CustomPage_txt{'29'}</td>
                <td class="windowbg2"><b>$CustomPage_txt{'29a'} <span class="important">$id<span></b></td>
                <td class="windowbg2"><a href="$adminurl?action=pagedelete2;id=$id">$CustomPage_txt{'30'}</a> | <a href="$adminurl?action=custompage">$CustomPage_txt{'31'}</a></td>
            </tr>
        </table>
    </div>
~;

    $yytitle = $CustomPage_txt{'36'};
    admintemplate();
    return;
}

sub PageDelete2 {
    my $id = $INFO{'id'};
    unlink "$vardir/Pages/$id.txt";
    unlink "$vardir/Pages/$id.count";
    our ($SET);
    fopen( 'SET', '<', "$vardir/Mods/custompage.txt" );
    my @pages = <$SET>;
    fclose('SET');
    my @output = ();

    foreach my $line (@pages) {
        if ( $line !~ /\A\Q$id\E[|]/ixsm ) {
            push @output, $line;
        }
    }
    my $output = join q{}, @output;
    our ($SETT);
    fopen( 'SETT', '>', "$vardir/Mods/custompage.txt" );
    print {$SETT} $output or croak "$croak{'print'} output";
    fclose('SETT');
    $yysetlocation = "$adminurl?action=custompage";
    redirectexit();
    return;
}

1;
